December 2014

Sun Mon Tue Wed Thu Fri Sat
  1 2 3 4 5 6
7 8 9 10 11 12 13
14 15 16 17 18 19 20
21 22 23 24 25 26 27
28 29 30 31      










« Creating a spline-segment multileader in AutoCAD using .NET | Main | AU Unplugged session on AutoCAD development »

September 06, 2007

Creating an AutoCAD multileader spraying out from central text using .NET

Some more fun with multileaders... this post shows some code that adds multiple leader lines to a multileader/MLeader, each of them "spraying" out from the central text. We ask the user for the central point and the location of the first leader along with the number of leader lines to "spray". These lines then get created at evenly spaced angles around from this initial location.

I can't think of anything immediately useful about this technique, other than it was fun to write the code and it shows how to add multiple leader lines. It also generates some fun results. :-)

Here's the C# code:

using Autodesk.AutoCAD.Runtime;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.EditorInput;

using Autodesk.AutoCAD.Geometry;


namespace DimensionLibrary

{

  public class DimensionCommands

  {

    [CommandMethod("spray")]

    static public void SprayMultiLeader()

    {

      Document doc =

        Application.DocumentManager.MdiActiveDocument;

      Editor ed = doc.Editor;

      Database db = doc.Database;


      // Get the start point of the leader

      PromptPointResult ppr =

        ed.GetPoint(

          "\nSpecify position of text: "

        );

      if (ppr.Status != PromptStatus.OK)

        return;

      Point3d startPt = ppr.Value;


      // Get the end point of the leader

      PromptPointOptions ppo =

        new PromptPointOptions(

          "\nSpecify first arrowhead location: "

        );

      ppo.BasePoint = startPt;

      ppo.UseBasePoint = true;

      ppr = ed.GetPoint(ppo);

      if (ppr.Status != PromptStatus.OK)

        return;

      Point3d endPt = ppr.Value;


      // Get the number of leader lines

      // to "spray" out from the center

      PromptIntegerOptions pio =

        new PromptIntegerOptions(

          "\nNumber of leader lines <1>: "

        );

      pio.AllowNone = true;

      pio.AllowZero = false;

      PromptIntegerResult pir =

        ed.GetInteger(pio);

      int numLines;

      if (pir.Status == PromptStatus.None)

        numLines = 1;

      else

      {

        if (pir.Status != PromptStatus.OK)

          return;

        else

          numLines = pir.Value;

      }


      Transaction tr =

        db.TransactionManager.StartTransaction();

      using (tr)

      {

        try

        {

          BlockTable bt =

            (BlockTable)tr.GetObject(

              db.BlockTableId,

              OpenMode.ForRead

            );

          BlockTableRecord btr =

            (BlockTableRecord)tr.GetObject(

              bt[BlockTableRecord.ModelSpace],

              OpenMode.ForWrite

            );


          // Create the MLeader

          MLeader mld = new MLeader();

          for(int i=0; i < numLines; i++)

          {

            // Each leader line sprays out

            // at a different angle

            Vector3d vec = endPt - startPt;

            vec =

              vec.RotateBy(

                i * 2 * System.Math.PI / numLines,

                mld.Normal

              );

            Point3d landPt = startPt + vec;

            int ldNum = mld.AddLeader();

            int lnNum = mld.AddLeaderLine(ldNum);

            mld.AddFirstVertex(lnNum, landPt);

            mld.AddLastVertex(lnNum, startPt);

          }

          mld.LeaderLineType =

            LeaderType.SplineLeader;


          // Create the MText

          MText mt = new MText();

          mt.Contents =

            "Multileader with " +

            numLines.ToString() +

            " \nradial splines";


          mld.ContentType =

            ContentType.MTextContent;

          mld.MText = mt;

          mld.TextLocation = startPt;


          // Add the MLeader

          btr.AppendEntity(mld);

          tr.AddNewlyCreatedDBObject(mld, true);


          tr.Commit();

        }

        catch (Exception ex)

        {

          ed.WriteMessage("\nException: " + ex.Message);

          // Would also happen automatically

          // if we didn't commit

          tr.Abort();

        }

      }

    }

  }

}

Here's a 7-line multileader created by the SPRAY command:

Mleader_multiple_segment_spline

TrackBack

TrackBack URL for this entry:
http://www.typepad.com/services/trackback/6a00d83452464869e200e54ed80bc88833

Listed below are links to weblogs that reference Creating an AutoCAD multileader spraying out from central text using .NET:

blog comments powered by Disqus

Feed/Share

10 Random Posts